//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Dictionary.h"
#include "LoadDic.h"
#include <fstream.h>
#include <iostream.h>

//---------------------------------------------------------------------------

#pragma package(smart_init)


Dictionary::Dictionary(int dim):
  Vector<string>(dim)
{
}

Dictionary::~Dictionary()
{
}

//-------------------------------------------------------

void Dictionary::InsertOrdered(const string& str)
{
   if( IsFull() )
       Expand();
   int pos = this->position;
   while( pos>0 && data[pos-1]> str)
   {
     data[pos] = data[pos-1];
     pos--;
   }
   data[pos]=str;
   position++;
}

void Dictionary::Insert(const string& str)
{
  if ( !Has(str) )
     InsertOrdered(str);
}

bool Dictionary::ReadDict(char *file){
   ifstream in(file);
   if( in ) {
      string aux;
      this->Clear();
      while( true )
      {
        in >> aux ;

           if( in.eof() )
           break;
           Insert(aux);

      }
      in.close();
      return true;
  }
  else
    in.close();
    return false;

}

bool Dictionary::ReadFile(char *filename){

  ifstream in(filename);
  if( in ) {
      string str, aux, orig;
      in.seekg(0,ios::end);
      Form2->ProgressBar1->Min=0;
      Form2->ProgressBar1->Max=(int)in.tellg();
      in.seekg(0,ios::beg);
      bool anular;
      this->Clear();
      while( true )
      {
        in >> str ;
        for (int i=0;i<str.size();i++)
           str[i]=chtolower(str[i]);
        orig=str;
        anular=false;


        for (int i=str.size()-1;i>=0;i--)
           if (!ConvertChar(str[i])){
              if(str[i]=='-' || str[i]=='.' || str[i]==',' || str[i]=='\'' || //corta simbolos das palavras
              str[i]==';' || str[i]==':' || str[i]=='_' || str[i]=='?' ||
              str[i]=='!' || str[i]=='\"' || str[i]=='(' || str[i]==')'){
                if (i<orig.size()-1){
                   for (int j=i+1;j<str.size();j++)
                      aux+=str[j];
                   Insert(aux);
                   aux.clear();
                }
                str.resize(i);
                orig.resize(i);
                //ShowMessage(orig.c_str());
                i=str.size();
              }else{
                anular=true;
                break;
              }
           }

           
        if (anular)
           continue;

        Form2->ProgressBar1->Position=(int)in.tellg();

        if (orig!="")
           Insert(orig);
        if( in.eof() )
           break;
      }
      in.close();
      Form2->ProgressBar1->Position=0;
      return true;
  }
  else
    return false;

}

bool Dictionary::AppendFile(char *filename){

  ifstream in(filename);
  if( in ) {
      string str, aux, orig;
      in.seekg(0,ios::end);
      Form2->ProgressBar1->Min=0;
      Form2->ProgressBar1->Max=(int)in.tellg();
      in.seekg(0,ios::beg);
      bool anular;
      while( true )
      {
        in >> str ;
        for (int i=0;i<str.size();i++)
           str[i]=chtolower(str[i]);
        orig=str;
        anular=false;


        for (int i=str.size()-1;i>=0;i--)
           if (!ConvertChar(str[i])){
              if(str[i]=='-' || str[i]=='.' || str[i]==',' || str[i]=='\'' ||
              str[i]==';' || str[i]==':' || str[i]=='_' || str[i]=='?' ||
              str[i]=='!' || str[i]=='\"' || str[i]=='(' || str[i]==')'){
                if (i<orig.size()-1){
                   for (int j=i+1;j<str.size();j++)
                      aux+=str[j];
                   Insert(aux);
                   aux.clear();
                }
                str.resize(i);
                orig.resize(i);
                //ShowMessage(orig.c_str());
                i=str.size();
              }else{
                anular=true;
                break;
              }
           }

        if (anular)
           continue;

        Form2->ProgressBar1->Position=(int)in.tellg();

        if (orig!="")
           Insert(orig);
        if( in.eof() )
           break;
      }
      in.close();
      Form2->ProgressBar1->Position=0;
      return true;
  }
  else
    return false;

}

void Dictionary::WriteDict(char *filename){
   ofstream out(filename);
   for(int i=0 ; i < Elements() ; i++ )
      out<<data[i]<<endl;
   out.close();
}


bool Dictionary::Has(const string& str) const {
  int ini=0;
  int fim=Elements()-1;
  while(ini<=fim){
     int middle =  (ini+fim)/2;
     if (data[middle]==str)
         return true;
     if (str>data[middle])
        ini= middle +1;
     else
         fim = middle -1;
  }

  return false;
}


bool Dictionary::ConvertChar(char &ch){

        if (ch>=-32 && ch<=-28)
                ch='a';
        if (ch>=-24 && ch<=-21)
                ch='e';
        if (ch>=-20 && ch<=-18)
                ch='i';
        if (ch>=-14 && ch<=-11)
                ch='o';
        if (ch>=-7 && ch<=-4)
                ch='u';
        if (ch=='')
                ch='c';
        if (ch=='')
                ch='n';
        if (ch=='' || ch=='')
                ch='y';

        if (ch>'z' || ch<'a')
                return false;
        return true;
}


char Dictionary::chtolower(char &ch){

        if (ch>'A' && ch<'Z')
                return tolower(ch);

        if ((ch>=-64 && ch<=-60) || (ch>=-56 && ch<=-53) || (ch>=-52 && ch<=-50)
                 || (ch>=-46 && ch<=-43) || (ch>=-39 && ch<=-36))
                ch+=32;
        if (ch=='')
                ch='';
        if (ch=='')
                ch='';
        if (ch=='')
                ch='';
        return ch;
}
