//---------------------------------------------------------------------------

#ifndef OrderedVectorH
#define OrderedVectorH
//---------------------------------------------------------------------------
#include <iostream.h>
#include "VectorException.h"
#include "Vector.h"

template <class ElemType>
class OrderedVector:public Vector<ElemType> {

        private:
        ElemType *tmp;
        int CUTOFF;

        public:
        OrderedVector<ElemType>(int dim=10, int CO=200);
        virtual ~OrderedVector();
        virtual void swap(int i, int j);

        //virtual void gnomeSort();
        //virtual void heapsort();
        virtual void BubbleSort();
        virtual void BubbleSort1();
        virtual void BubbleSort2();
        virtual void Straight();
        virtual void Straight1();
        virtual void InsertionSort(int left, int right);
        virtual void Insertion();
        virtual void Shell();
        virtual void Shell1();
        virtual void Shell2();
        virtual void Shell3();

        virtual void Join(int left, int right);
        virtual void Merge(int left, int right);
        virtual void Merge();

        virtual int Partition(int left, int right);
        virtual void Quick(int left, int right);
        virtual void Quick();

        virtual int Partition2(int left, int right);
        virtual void Quick2(int left, int right);
        virtual void Quick2();
        virtual void Quick3(int left, int right);
        virtual void Quick3();
        virtual void Quick4();
        virtual void Quick5();
        virtual void QuickSortHybrid(int left, int right);
        virtual void SetCUTOFF(int x);
        virtual void gnomeSort();
        virtual void heapsort();


};

template <class ElemType>
OrderedVector<ElemType>::OrderedVector(int dim, int CO):Vector<ElemType>(dim)
{
  //randomize();
  //for (int i = 0; i < dim; i++)
  //  Insert(dim-random(2*dim));
  CUTOFF=CO;
}

template <class ElemType>
OrderedVector<ElemType>::~OrderedVector()
{
}

//------------------------------------------------------------------------------
template <class ElemType>
void OrderedVector<ElemType>::swap(int i, int j){
        ElemType aux= data[i];
        data[i] = data[j];
        data[j] = aux;
}
//------------------------------------------------------------------------------
template <class ElemType>
void OrderedVector<ElemType>::BubbleSort(){
ElemType aux;
  for(int i=0; i< Elements() ; i++ )
      for( int j=0; j< Elements()-1 ; j++){
            if(data[j] > data[j + 1] ){
                aux = data[j];
                data[j] = data[j + 1];
                data[j + 1 ] = aux;
            }
      }
}

//------------------------------------------------------------------------------
template <class ElemType>
void OrderedVector<ElemType>::BubbleSort1(){
ElemType aux;
bool isOK;
for(int i=0; i< Elements() ; i++ )
{
  isOK = true;
  for( int j=0; j< Elements()-1 ; j++){
            if(data[j] > data[j + 1] ){
                aux = data[j];
                isOK = false;
                data[j] = data[j + 1];
                data[j + 1 ] = aux;
            }
  }
  if ( isOK )
        break;
  }
}

//------------------------------------------------------------------------------
template <class ElemType>
void OrderedVector<ElemType>::BubbleSort2(){
ElemType aux;
for(int i=0; i< Elements() ; i++ )
  for( int j=i+1; j< Elements() ; j++){
            if(data[j] < data[i] ){
                aux = data[j];
                data[j] = data[i];
                data[i] = aux;
            }
  }

}

//------------------------------------------------------------------------------
template <class ElemType>
void OrderedVector<ElemType>::Straight(){
ElemType aux;
int pos;
for(int i=0; i< Elements() ; i++ ) {
  pos=i;
  for( int j= i + 1; j< Elements() ; j++) {
        if(data[j] < data[pos] )
             pos = j;
        }
    swap(pos,i);
   }

}

//------------------------------------------------------------------------------
template <class ElemType>
void OrderedVector<ElemType>::Straight1(){
int aux_max,aux_min;
int pos1,pos2;
for(int i=0; i< Elements()/2 ; i++ ) {
  pos1=i;
  pos2=Elements()-i-1;
  aux_min=pos1;
  aux_max=pos2;
  for( int j= pos1; j<= pos2 ; j++) {
        if(data[j] < data[aux_min] )
             aux_min = j;
        if(data[j] > data[aux_max] )
             aux_max = j;
  }

    if (aux_max!=pos1){
        swap(pos1,aux_min);
        swap(pos2,aux_max);
    }else if (aux_min!=pos2){
        swap(pos2,aux_max);
        swap(pos1,aux_min);
    }else
        swap(pos1,pos2);

}

}
//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::InsertionSort(int left, int right)
{
ElemType aux;
for(int i=left+1; i<= right ; i++ ){
   aux= data[i];
   int pos= i;
   while( pos>0 && aux < data[pos-1]  ){
      data[pos] = data[pos - 1];
      pos--;
   }
   data[pos] = aux;
}
}
//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Insertion()
{
  InsertionSort(0, Elements() -1);
}
//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Shell(){
    int outer, inner;
    ElemType  tmp;
    int h=1;
    while(h < Elements() /3)
      h = h*3 +1;             // (1 4 13 40 121 . . .)
    while( h >0)
    {
       for( outer= h ; outer < Elements() ; outer++)  {
            tmp = data[outer];
            inner = outer;
            while( inner > h-1 && data[inner -h] >= tmp){
               data[inner] = data[inner-h];
               inner -= h;
            }
            data[inner] = tmp;
       }
       h = (h-1) /3;
    }//passo
}
//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Shell1(){
    int outer, inner;
    ElemType  tmp;
    int h=1;
    while(h < Elements() /3)
      h = h*3 +1;             // (1 4 13 40 121 . . .)
    while( h >0)
    {
       for( outer= h ; outer < Elements() ; outer++)  {
            tmp = data[outer];
            inner = outer;
            while( inner > h-1 && data[inner -h] >= tmp){
               data[inner] = data[inner-h];
               inner -= h;
            }
            data[inner] = tmp;
       }
       h = h /2;
    }//passo
}
//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Shell2(){
    int outer, inner;
    ElemType  tmp;
    int h=1;
    while(h < Elements() /3)
      h = h*3 +1;             // (1 4 13 40 121 . . .)
    while( h >0)
    {
       for( outer= h ; outer < Elements() ; outer++)  {
            tmp = data[outer];
            inner = outer;
            while( inner > h-1 && data[inner -h] >= tmp){
               data[inner] = data[inner-h];
               inner -= h;
            }
            data[inner] = tmp;
       }
       h = h /2.2;
    }//passo
}
//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Shell3(){
    int outer, inner;
    ElemType  tmp;
    int h=1;
    while(h < Elements() /3)
      h = h*3 +1;             // (1 4 13 40 121 . . .)
    while( h >0)
    {
       for( outer= h ; outer < Elements() ; outer++)  {
            tmp = data[outer];
            inner = outer;
            while( inner > h-1 && data[inner -h] >= tmp){
               data[inner] = data[inner-h];
               inner -= h;
            }
            data[inner] = tmp;
       }
       h = 5*h /11;
    }//passo
}

//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Join(int left, int right){
   int  middle =(left + right) /2;
   int  i = left;
   int  j = middle;
   int  k = 0;
   while(i < middle  && j <= right)   {
        if(data[i] < data[j])
          tmp[k++] = data[i++];
        else
          tmp[k++] = data[j++];
    } // while
    // copiar a parte ordenada da esquerda
   for( ; i < middle ; i++)
      tmp[k++] = data[i];
   for(i=0 ; i < k  ; i++ )
     data[left + i] = tmp[i];
}

//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Merge(int left, int right)
{
   // se tiver mais que 2 elementos
   if( right - left > 1)
   {
      int middle = ( right + left )/2;
      Merge(left , middle -1);
      Merge(middle, right);
      Join(left,right);
   }
 // Se tiver um ou dois elementos
   else {
      if(data[right] < data[left])
      {
        swap(left,right);
      }
   }
}

//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Merge()
{
  //Alocar espao para o array temporrio
  tmp = new ElemType[Elements()];
  Merge(0, Elements() -1);
  delete [] tmp;
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

template <class ElemType>
int OrderedVector<ElemType>::Partition(int left, int right)
{
  ElemType pivot = data[right];
  int lo = left;
  int hi = right-1;
  while(true)
  {
        while( data[lo] < pivot && lo<Elements()-1)
           lo++ ;
        while( pivot < data[hi] && hi>0)
           hi--;
        if( lo >= hi )
            break;
        swap(lo,hi);
        lo++;
        hi--;
     }
  swap(lo,right);
  return lo;
}

//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Quick(int left, int right)
{
  if( right > left )
  {
        int pivot = Partition( left, right);
        Quick(left, pivot - 1 );
        Quick(pivot + 1, right);
  }
}

//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Quick()
{
    Quick(0, Elements() -1);
}


//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

template <class ElemType>
int OrderedVector<ElemType>::Partition2(int left, int right)
{
  ElemType pivot = data[left];
  int lo = left+1;
  int hi = right;
  while(true)
  {
        while( data[lo] < pivot && lo<Elements()-1)
           lo++ ;
        while( pivot < data[hi] && hi>0)
           hi--;
        if( lo >= hi )
            break;
        swap(lo,hi);
        lo++;
        hi--;
     }
  swap(hi,left);
  return hi;
}

//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Quick2(int left, int right)
{
  if( right > left )
  {
        int pivot = Partition2( left, right);
        Quick2(left, pivot - 1 );
        Quick2(pivot + 1, right);
  }
}

//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Quick2()
{
   Quick2(0, Elements() -1);
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Quick3(int left, int right)
{
  if( right > left )
  {
        swap((left+right)/2, right);
        int pivot = Partition( left, right);
        Quick3(left, pivot - 1 );
        Quick3(pivot + 1, right);
  }
}
//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Quick3()
{
    Quick3(0, Elements() -1);
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Quick4()
{
    Quick(0, Elements() -1);
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::Quick5()
{
    QuickSortHybrid(0, Elements() -1);
}


//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>:: QuickSortHybrid(int left, int right)
{

 if( right - left > CUTOFF  )
  {
        int pivot = Partition( left, right);
        QuickSortHybrid(left, pivot - 1 );
        QuickSortHybrid(pivot + 1, right);
  }
 else
    InsertionSort( left, right);
}
//------------------------------------------------------------------------------

template <class ElemType>
void OrderedVector<ElemType>::SetCUTOFF(int x) {
  if( x < 0 || x >= position )
    throw VectorException("Get index ERROR: invalid index");
  CUTOFF=x;
}


template <class ElemType>
void OrderedVector<ElemType>::gnomeSort()
 {
   int i = 1;
   ElemType swapNum;
   while (i<Elements())
   {
     if (i==0 || data[i-1]<= data[i])
       i++; //Increment i
     else
     {
       //SWAP NUMBERS
       swapNum = data[i-1];
       data[i-1] = data[i];
       data[i] = swapNum;
       i--; //Decrement i
     }
   }
 }


//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
/*heapsort  um membro da familia de Selection sorts. Esta familia de algoritmos
funciona determinando o maior(ou menor) elemento da lista, metendo este no fim
(ou principio) da lista, continuando entao com o resto da lista. Straight corre
num tempo O(n2), mas o Heapsort realiza a sua tarefa eficientemente usando uma
estrutura de dados chamada heap, que  uma arvore binaria onde cada pai  maior
que qualquer dos seus filhos. Assim que os dados da lista tenham sido feita num
heap, o n da raiz  guarantido como o maior elemento. Este  removido e colocado
no final da lista, depois disto  feito o mesmo proceso at se organizar a lista.*/

template <class ElemType>
void OrderedVector<ElemType>::heapsort() {
  ElemType t;
  int n = Elements(), i = n/*>>1*/, j, w;
  while (true) {
    if (i>0)
       t = data[--i];
    else {
      if (--n<=0)
         return;
      t = data[n];
      data[n] = data[0];
    }

    j = i;
    w = (i/*<<1*/)+1;
    while (w<n) {
      if (w+1<n && data[w+1]>data[w])
      w++;
      if (data[w]>t) {
        data[j] = data[w];
        j = w;
        w = (j/*<<1*/)+1;
      }
      else break;
    }
    data[j] = t;
  }
}




#endif
